/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM
 * /builds/tinderbox/XR-Trunk/Darwin_8.8.4_Depend/mozilla/toolkit/components/places/public/nsITaggingService.idl
 */

package org.mozilla.interfaces;

public interface nsITaggingService extends nsISupports {

  String NS_ITAGGINGSERVICE_IID =
    "{962bf94f-e719-4cf6-8967-74ff5d2020df}";

  /**
   * Tags a URL with the given set of tags. Current tags set for the URL
   * persist. Tags in aTags which are already set for the given URL are
   * ignored.
   *
   * @param aURI
   *        the URL to tag.
   * @param aTags
   *        Array of tags to set for the given URL.
   */
  void tagURI(nsIURI aURI, String[] aTags, long aCount);

  /**
   * Removes tags from a URL. Tags from aTags which are not set for the
   * given URL are ignored.
   *
   * @param aURI
   *        the URL to un-tag.
   * @param aTags
   *        Array of tags to unset.
   */
  void untagURI(nsIURI aURI, String[] aTags, long aCount);

  /**
   * Retrieves all URLs tagged with the given tag.
   *
   * @param aTag
   *        Array of uris tagged with aTag.
   */
  nsIVariant getURIsForTag(String aTag);

  /**
   * Retrieves all tags set for the given URL.
   *
   * @param aURI
   *        a URL.
   * @returns array of tags.
   */
  nsIVariant getTagsForURI(nsIURI aURI);

}